/* System-Tick und Uhrzeit fr das STM32F103ZET6-Board */

#include "stdtypes.h"
#include "startup.h"
#include "STM32F103.h"
#include "systick.h"
#include "events.h"
#include "serial.h"
#include "sdio.h"


volatile long Ticks;
long OldTicks;


/******* Interrupt vom SysTick-Counter *************/
int iTicks;

__irq void SysTick_Handler (void)
{ long T;
  int i;

  SYSTICK_CTRL &=  ~(SYSTICK_CTRL_COUNTFLAG);  /* Interrupt zurckstellen */

  T = Ticks+1;                                 /* 1 ms Tick weiterstellen */
  Ticks = T;
  if ((T-OldTicks)<10) return;

                                               /* ab hier alle 10 ms */
  if (T >= 86400000)
  { Ticks = T = 0;                             /* wenn 1 Tag um ist */
    i = 0;
    while (i<numtimers)
    { if (CurrTimers[i].aEvent)
          CurrTimers[i].endzeit = CurrTimers[i].endzeit - 86400000;
      ++i;
    }
  }

  OldTicks = T;
  ++iTicks;
  if ((iTicks==20)||
      (iTicks==40)||
      (iTicks==60)||
      (iTicks==80))
      { Add_Event(id_200_milli); SDCardTest(); }

  if (iTicks >= 100)
     { iTicks = 0; Add_Event(idSekundeUm); }

  /* ladbare Timer bearbeiten */
   i = 0;
   while (i<numtimers)
   { if (CurrTimers[i].aEvent)
     { if (CurrTimers[i].endzeit < T)       /* ob abgelaufen */
       {                                    /* hier ggf. Flags auswerten */
         Add_Event(CurrTimers[i].aEvent);
         CurrTimers[i].aEvent = 0;
       }
     }
     ++i;
   }
}


void Warte_ms (long Millisekunden)
{ dword D;
  long  L;

  D = Ticks;
  L = Millisekunden;
  while (L>0)
  { if (D!=Ticks)
    { --L;
      D = Ticks;
    }
  }
}

/* der NVIC ist bereits von Do_Config() aufgesetzt */
void Systemtick_Init (void)
{ SYSTICK_LOAD = 8999;    /* sollte 1 ms ergeben */
  SYSTICK_VAL  = 0;
  SYSTICK_CTRL = 2 | 1;   /* HCLK/8, int, on */
  Ticks = OldTicks = iTicks = 0;
}

